#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xjf upx-3.08-src.tar.bz2
    cd upx-3.08-src/src
    ed -s Makefile >/dev/null <<EOF
/^CXXFLAGS += -O2/d
w
q
EOF
    make
    gcc -o upx *.o -Wl,-Bstatic -lucl -lstdc++ -Wl,-Bdynamic -lz
    strip -R .note -R .comment upx
    mkdir -p ../../upx/bin
    cp upx ../../upx/bin/
    sudo cp upx /usr/local/bin/
    cd ../..
#    rm -rf upx-3.08-src
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
